Drupal.media_getUploadProgress = function(fileid){
  $.ajax({
     url:      Drupal.settings.basePath + 'media_upload/progress',
     dataType: 'json',
     data:     "fileid=" + fileid + "&progressbar=" + $('#media_upload_progressbar').progressbar("option", "value"),
     success:  function(data) {
       if (data.filesize > 0) {
         $('#media_upload_filesize').html(Drupal.t('Total file size: !size', {'!size': bytesToSize(data.filesize)}));
       }
       $('#media_upload_percentage').html(' ' + Drupal.t('Complete: !pct%', {'!pct': data.done}) + ' ');
       $('#media_upload_progressbar').progressbar('option', 'value', data.done);
       if (data.done < 100) {
         setTimeout('Drupal.media_getUploadProgress("' + fileid + '")', 500);
       }
     }
  });
};

Drupal.media_startProgress = function(fileid) {
  $('#media_upload_progressbar').progressbar({value: 0});
  $('#media_upload_progress').show();
  $('#media_upload_frame').hide();
  setTimeout('Drupal.media_getUploadProgress("' + fileid + '")', 1000);
};

Drupal.media_uploadComplete = function() {
  $('#media_upload_progressbar').progressbar('option', 'value', 100);
  $('#media_upload_percentage').html(' ' + Drupal.t('Complete: !pct%', {'!pct': 100}) + ' ');
  window.location = Drupal.settings.page_url;
};

Drupal.behaviors.media_loadImagesBehavior = function() {
  Drupal.media_loadImages();
};

Drupal.media_loadImages = function() {
  $.ajax({
    url:     Drupal.settings.basePath + 'media_upload/generate_temp_thumbs',
    success: function(data) {
      Drupal.media_loadThumbs(data);
    }
  });
};

Drupal.media_loadThumbs = function(data) {
  $('.media-upload-pane').each(function() {
    var hash = $(this).find('img').attr('id');
    $('#' + hash).replaceWith("<img src='" + Drupal.settings.basePath + "media_upload/temp/" + hash + "'>");
  });
  $('#media-loading-thumbs').hide();
};
