<?php

/**
 * @file
 * Views file for media nodes
 */

/*
 * Implementation of hook_views_data(). Used to tell views about non-CCK database tables.
 */
function media_views_data() {
  $data = array();
  $data['media_files']['table']['group'] = t('File Upload');
  $data['media_files']['table']['join']['node'] = array(
      'left_field' => 'nid',
      'field' => 'nid',
  );

  // Fields
  $data['media_files']['uploadedfilename'] = array(
    'title' => t('File Name'),
    'help' => t('The uploaded file name.'),
    'field' => array(
      'click sortable' => TRUE,
      'handler' => 'views_handler_field_node',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
  );
  $image_sizes = variable_get('image_sizes', '');
  foreach ($image_sizes as $image_size) {
    if ($image_size['label'] != '') {
      $image_labels[] = $image_size['label'];
    }
  }
  $data['media_files']['filename'] = array(
    'title' => t('Image Size'),
    'help' => t('The nice name for the size. This will be <em>original</em> for all but images which also have %sizes', array('%sizes' => implode(', ', $image_labels))),
    'field' => array(
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
  );
  $data['media_files']['filesize'] = array(
    'title' => t('File Size'),
    'help' => t('The total file size of the file'),
    'field' => array(
      'click sortable' => TRUE,
      'handler' => 'views_handler_field_file_size',
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_numeric',
    ),
  );

  return $data;
}
