<?php

// TODO: UI: add refresh this/all, mark (un)read this/all
// set list of default feeds to suggest subscribing to
// academic portal

define('MY_ACAD_KEY', 999999999);
define('USE_COMPRESSED_JS', $_SERVER['SERVER_NAME'] != 'dwilga-linux1.amherst.edu');

function _feedview_list_feeds($settings) {
  global $user;

  rss_page_load_as_user();
  $result = db_query("SELECT nid FROM {node} WHERE type='portal_page' AND status=1 ORDER BY sticky DESC, changed DESC");
  $seen_cats = array();
  while ($n = db_fetch_object($result)) {
    $node = node_load($n->nid);
    if ($node->nid && mm_content_user_can_node($node, 'r')) {
      $seen_cats[] = $node->nid;    // consider a node "seen" even if it's not shown to the user right now, because it might be again at some point
      if (!_feedview_condition($node)) {
        continue;
      }
      $title = trim(_rss_page_add_vars($node->title, $node));
      if ($title == '') {
        $title = t('Amherst College Feeds');
        if ($default_node) {
          $node->nid = $default_node;
        }
        else {
          $default_node = $node->nid;
        }
      }
      if (!isset($out[$node->nid])) {
        $out[$node->nid] = array(
          'title' => $title,
          'readonly' => TRUE,
          'list' => array(),
          'expanded' => !$settings['collapsed'][$node->nid]
        );
      }
      foreach ($node->rss_feeds as $feed) {
        if ($is_sel = $settings['selected'][0] == $node->nid && $settings['selected'][1] == $feed->fid) {
          $out[$node->nid]['expanded'] = TRUE;
          $have_sel = TRUE;
        }
        $out[$node->nid]['list'][$feed->fid] = array('text' => _rss_page_add_vars($feed->name, $node), 'selected' => $is_sel);
      }
    }
  }

  if (module_exists('academics')) {
    $list = academics_my_academics();
    if ($list) {
      $all = array();
      $out[MY_ACAD_KEY] = array(
        'title'    => t('My Academics'),
        'readonly' => TRUE,
        'list'     => array(),
        'expanded' => !$settings['collapsed'][MY_ACAD_KEY]
      );

      foreach ($list as $key => $value) {
        if ($value['links']) {
          $sofar = array();
          foreach ($value['links'] as $tid => $data) {
            if ($is_sel = $settings['selected'][0] == MY_ACAD_KEY && $settings['selected'][1] == $tid) {
              $out[MY_ACAD_KEY]['expanded'] = TRUE;
              $have_sel = TRUE;
            }

            if (is_numeric($tid)) {
              $out[MY_ACAD_KEY]['list'][$tid] = array('text' => $value['id'] . ': ' . $data['text'], 'selected' => $is_sel, 'isTid' => TRUE, 'button' => array(array('text' => t('Course'), 'url' => url(mm_content_get_mmtid_url($value['tid'])),
                'tip' => array('title' => 'Course', 'text' => 'Go to the site for this course'))));
              $sofar[] = $tid;
            }
            else {
              foreach ($sofar as $s) {
                $out[MY_ACAD_KEY]['list'][$s]['button'][] = array('text' => $data['short'], 'url' => $tid, 'tip' => $data['tip']);
              }
            }
          }

          foreach (array_keys($out[MY_ACAD_KEY]['list']) as $key) {
            $out[MY_ACAD_KEY]['list'][$key]['button'] = array_merge($out[MY_ACAD_KEY]['list'][$key]['button'], $all);
          }
        }
        else {
          $all[] = array('text' => $value['title'], 'url' => $key, 'tip' => $value['tip']);
        }
      }

      foreach (array_keys($out[MY_ACAD_KEY]['list']) as $key) {
        $out[MY_ACAD_KEY]['list'][$key]['button'] = array_merge($out[MY_ACAD_KEY]['list'][$key]['button'], $all);
        uasort($out[MY_ACAD_KEY]['list'][$key]['button'], '_feedview_name_sort');
      }
    }
  }

  $q = mm_query("SELECT n.nid FROM {mm_node2tree} t INNER JOIN {node} n ON n.nid = t.nid AND n.type = 'rss_page' WHERE mmtid = %d", $user->user_portal_mmtid);
  while ($n = $q->next()) {
    $node = node_load($n->nid);
    if ($node->nid && mm_content_user_can_node($node, 'r')) {
      $seen_cats[] = $node->nid;
      $title = trim($node->title);
      if ($title == '') {
        $title = t('Untitled');
      }
      $out[$node->nid] = array('title' => $title, 'list' => array(), 'expanded' => !$settings['collapsed'][$node->nid]);
      if ($node->rss_feeds) {
        foreach ($node->rss_feeds as $feed) {
          if ($is_sel = $settings['selected'][0] == $node->nid && $settings['selected'][1] == $feed->fid) {
            $out[$node->nid]['expanded'] = TRUE;
            $have_sel = TRUE;
          }
          $out[$node->nid]['list'][$feed->fid] = array('text' => $feed->name, 'data' => $feed->data, 'type' => $feed->type, 'selected' => $is_sel);
        }
      }
    }
  }

  if ($out) {
    uasort($out, '_feedview_title_sort');
    foreach ($out as $nid => &$attribs) {
      uasort($attribs['list'], '_feedview_name_sort');
    }
    if (!$have_sel) {
      $key0 = array_keys($out);
      if ($key1 = array_keys($out[$key0[0]]['list'])) {
        $out[$key0[0]]['expanded'] = TRUE;
        $out[$key0[0]]['list'][$key1[0]]['selected'] = TRUE;
      }
    }
  }

  if ($settings['collapsed']) {
    foreach (array_diff(array_keys($settings['collapsed']), $seen_cats) as $cat) {
      if ($settings['collapsed'][$cat]) {
        $update_settings = TRUE;
        unset($settings['collapsed'][$cat]);
      }
    }
  }
  if ($update_settings) {
    db_query("UPDATE {rss_page_settings} SET settings='%s' WHERE uid=%d", serialize($settings), $user->uid);
  }
//  debug_add_dump($out);
  return $out;
}

function _feedview_title_sort($a, $b) {
  if ($a['readonly'] != $b['readonly']) {
    return $a['readonly'] ? -1 : 1;
  }
  return strnatcasecmp($a['title'], $b['title']);
}

function _feedview_name_sort($a, $b) {
  return strnatcasecmp($a['text'], $b['text']);
}

function _feedview_condition($node) {
  if (($cond = trim($node->rss_page['condition'])) != '') {
    $cond = _rss_page_add_vars($cond, $node);
    if (empty($cond) || drupal_eval("<? print($cond) ?>") == FALSE) {
      return FALSE;
    }
  }
  return TRUE;
}

function feedview_get($type, $key) {
  global $base_url, $locale;

  if ($type == 'bytid') {
    if (!($tree = mm_content_get($key, MM_GET_FLAGS))) {
      $status = 404;
    }
    else if (!mm_content_user_can($key, 'r')) {
      $status = 403;
    }
    else {
      $node = (object)array('rss_page' => rss_page_get_options());
      _rss_page_feed_from_cat($key, NULL, $node, 0, NULL, NULL, '', 'fulltext', $newest, $feed, FALSE, isset($tree->flags['acad_ereserves']) ? $tree->parent : FALSE);
      if ($feed) {
        $feeds[0] = (object)$feed;
      }
      $parent = MY_ACAD_KEY;
    }
  }
  else {
    $nid = db_result(db_query('SELECT nid FROM {rss_page_feed} WHERE fid = %d', $key));
    if ($nid) {
      $node = node_load($nid);
      if ($node->nid && mm_content_user_can_node($node, 'r')) {
        if (_feedview_condition($node)) {
          $feeds = _rss_page_load_feeds($node, $key, '', $rss_link, 'fulltext');
        }
        $parent = $node->nid;
      }
      else $status = 403;
    }
    else $status = 404;
  }

  if ($status) {
    drupal_set_header('Status: '.$status);
    exit();
  }

  $namespaces = array('xmlns:dc="http://purl.org/dc/elements/1.1/"');
  $base = $base_url . '/' . $_GET['q'];
  $channel = array(
    'version' => '2.0',
    'title' => variable_get('site_name', 'Drupal') .' - '. $feeds[0]->feed_title,
    'link' => $feeds[0]->feed_link ? url($feeds[0]->feed_link) : '',
    'description' => '', // DEBUG: print_r($feeds,1),
    'language' => $locale
  );

  if ($feeds) {
    if ($feeds[0]->error) {
      $items = format_rss_item(t('Error loading feed'), '', $feeds[0]->error);
    }
    else if ($feeds[0]->items) {
      foreach ($feeds[0]->items as $item) {
        $extra = array(array('key' => 'pubDate',
                             'value' => date('r', $item->date)));
        if (isset($item->link)) {
          $extra[] = array('key' => 'guid',
                           'value' => $item->link['value'],
                           'attributes' => array('isPermaLink' => $item->link['permalink']));
        }
        if (isset($item->uid)) {
          $creator = mm_content_uid2name($item->uid);
          $extra[] = array('key' => 'author',
                           'value' => $creator);
        }
        if ($item->extra) {
          foreach ($item->extra as $element) {
            if ($element['namespace']) {
              $namespaces = array_merge($namespaces, $element['namespace']);
            }
          }
          $extra = array_merge($extra, $item->extra);
        }

        $items .= format_rss_item($item->title, url($item->link['value'], array('absolute' => TRUE)), $item->description, $extra);
      }
    }
  }

  $output = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
  $output .= "<rss version=\"". $channel['version'] ."\" xml:base=\"". $base ."\" ". implode(' ', $namespaces) .">\n";
  $output .= format_rss_channel($channel['title'], $channel['link'], $channel['description'], $items, $channel['language']);
  $output .= "</rss>\n";

  _feedview_state('selected', $parent, $key);
  drupal_set_header('Content-Type: text/xml;charset=utf-8');
  print $output;
  exit();
}

function feedview_tags() {
  $out = array();
  $after = array();
  foreach (taxonomy_form_all(TRUE) as $taxo => $terms) {
    foreach ($terms as $value => $text) {
      if ($_POST['query'] == '' || ($pos = stripos($text, $_POST['query'])) === 0) {
        $out[] = array('value' => $value, 'text' => $text);
      }
      else if ($pos !== FALSE) {
        $after[] = array('value' => $value, 'text' => $text);
      }
    }
  }

  usort($out, '_feedview_cmp');
  usort($after, '_feedview_cmp');
  print drupal_json(array_merge($out, $after));
  exit();
}

function _feedview_cmp($a, $b) {
  return strnatcasecmp($a['text'], $b['text']);
}

function _feedview_get_state() {
  global $user;

  $set = db_fetch_object(db_query('SELECT settings, 1 AS `exists` FROM {rss_page_settings} WHERE uid=%d', $user->uid));
  if (!$set) {
    $set = (object)array('settings' => array());
  }
  else {
    $set->settings = unserialize($set->settings);
  }

  return $set;
}

function feedview_page() {
  $set = _feedview_get_state();
  if (!isset($set->settings['panels']['summary']))
             $set->settings['panels']['summary'] = TRUE;
  if (!isset($set->settings['panels']['panel']['height']))
             $set->settings['panels']['panel']['height'] = 400;
  $height = $set->settings['panels']['panel']['height'];

  $mypath = drupal_get_path('module', 'rss_page') . '/feedviewer';

  drupal_add_css('misc/ext/resources/css/ext-all.css');
  drupal_add_css("$mypath/feed-viewer.css");
  if (USE_COMPRESSED_JS) {
    // this file is created using do-compress.sh
    drupal_add_js("$mypath/feedviewer-compressed.js", 'module', 'footer');
  }
  else {
    drupal_add_js('misc/ext/adapter/ext/ext-base.js', 'module', 'header', FALSE, TRUE, FALSE);
    drupal_add_js('misc/ext/ext-all-debug.js', 'module', 'header', FALSE, TRUE, FALSE);
    drupal_add_js("$mypath/FeedViewer.js", 'module', 'footer', FALSE, TRUE, FALSE);
    drupal_add_js("$mypath/FeedWindow.js", 'module', 'footer', FALSE, TRUE, FALSE);
    drupal_add_js("$mypath/FeedGrid.js", 'module', 'footer', FALSE, TRUE, FALSE);
    drupal_add_js("$mypath/MainPanel.js", 'module', 'footer', FALSE, TRUE, FALSE);
    drupal_add_js("$mypath/FeedPanel.js", 'module', 'footer', FALSE, TRUE, FALSE);
  }

  $icons = array();
  if (module_exists('media')) {
    $icon_base = base_path() . drupal_get_path('module', 'media'). '/icons/';
    foreach (media_get_icons() as $type)
      $icons[$type->mime] = $icon_base . $type->icon;
  }

  drupal_add_js(
    array('MMFV' =>
      array('clear'       => base_path().drupal_get_path('module', 'monster_menus').'/images/clear.gif',
            'getFeed'     => base_path().'myportal/feed',
            'getFeedTid'  => base_path().'myportal/bytid',
            'tagList'     => base_path().'myportal/tags',
            'addFeed'     => base_path().'myportal/add/fv',
            'delete'      => base_path().'myportal/del',
            'saveState'   => base_path().'myportal/state',
            'getTree'     => base_path().'myportal/tree',
            'allowAddDel' => user_access('create rss pages'),
            'treeTop'     => 1,
            'lastState'   => $set->settings['panels'],
            'feeds'       => _feedview_list_feeds($set->settings),
            'mediaIcons'  => $icons,
      )
    ), 'setting');

  return <<<EOF
<div id="feedviewer-main" style="height: ${height}px"></div>
<!-- Template used for Feed Items -->
<textarea id="preview-tpl" style="display:none;">
    <div class="post-data">
        <span class="post-date">{pubDate:date("M j, Y, g:i a")}</span>
        <h3 class="post-title">{title}</h3>
        {content:this.getAuthor}
    </div>
    {content:this.getEnclosure}
    <div class="post-body">{content:this.getBody}</div>
</textarea>
EOF;
}

function _feedview_state($arg1, $arg2, $arg3) {
  global $user;

  $set = _feedview_get_state();
  switch ($arg1) {
    case 'selected':
      $set->settings['selected'] = array(intval($arg2), intval($arg3));
      break;

    case 'expand':
      $arg2 = intval($arg2);
      if ($arg2) {
        unset($set->settings['collapsed'][$arg2]);
      }
      break;

    case 'collapse':
      $arg2 = intval($arg2);
      if ($arg2) {
        $set->settings['collapsed'][$arg2] = TRUE;
      }
      break;

    case 'summary':
      $set->settings['panels']['summary'] = $arg2 === 'true';
      break;

    case 'preview':
      $set->settings['panels']['preview'] = $arg2;
      break;

    case 'topic-grid':    // ignore column changes, for now
    case 'columns':
      break;

    case 'feed-tree':
    case 'bottom-preview':
    case 'panel':
      foreach ($_POST as $key => $val) {
        if ($key == 'collapsed' || $key == 'width' || $key == 'height') {
          if ($val === 'true') {
            $set->settings['panels'][$arg1][$key] = TRUE;
          }
          else if ($val === 'false') {
            unset($set->settings['panels'][$arg1][$key]);
          }
          else if (intval($val) == $val) {
            $set->settings['panels'][$arg1][$key] = intval($val);
          }
          else {
            $set->settings['panels'][$arg1][$key] = $val;
          }
        }
      }
  }

  if ($set->exists) {
    db_query("UPDATE {rss_page_settings} SET settings='%s' WHERE uid=%d", serialize($set->settings), $user->uid);
  }
  else {
    db_query("INSERT INTO {rss_page_settings} (uid,settings) VALUES(%d,'%s')", $user->uid, serialize($set->settings));
  }
}

function feedview_state($arg1, $arg2, $arg3) {
  _feedview_state($arg1, $arg2, $arg3);
  print 'OK';
  exit();
}

function feedview_tree() {
  $mmtid = intval($_GET['node']);
  if (!$mmtid) {
    drupal_access_denied();
  }

  $out = array();
  $params = array(
    MM_GET_TREE_DEPTH            => 1,
    MM_GET_TREE_FILTER_NORMAL    => TRUE,
    MM_GET_TREE_FILTER_USERS     => TRUE,
    MM_GET_TREE_RETURN_KID_COUNT => TRUE,
    MM_GET_TREE_RETURN_PERMS     => TRUE,
  );
  $list = mm_content_get_tree($mmtid, $params);
  $root = array_shift($list);
  foreach ($list as $item) {
    $name = mm_content_expand_name($item->name);
    if ($name[0] != '.' && !$item->perms['IS_RECYCLED']) {
      $out[] = array(
        'id' => $item->mmtid,
        'text' => $name,
        'leaf' => $item->state == 'leaf' || !$item->perms['r'],
        'disabled' => $item->mmtid == mm_content_users_mmtid() || $item->is_virtual || !$item->perms['r']
      );
    }
  }

  unset($list);
  print drupal_json($out);
  exit();
}
